;===============;
;New Sprite	    ;
;===============;

;;;;;;;;;;;;;;;;;;;;;;;;;

print "INIT ",pc
	stz $c2,X
	RTL

print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR Run
	PLB
	RTL

Return:
	RTS

Run:
JSR Graphics 
LDA $9D
BNE Return
LDA $14C8,x
CMP #$08
BNE Return
JSR SUB_OFF_SCREEN_X0
JSL $01802A
JSL $019138
LDA $C2,x
JSL $0086DF
dw .st1
dw .st2
dw .st3
dw .st4

.st1
STZ $1504,X	;always stand frame
LDA #$16
STA $00
JSR prox
CMP #$00
BEQ .stof
RTS
.stof
LDA #$20
STA $163E,x
LDA #$C0
STA $AA,x
INC $C2,x
RTS

.st2
LDA $163E,x
BEQ .frm2
LDA #$01
STA $1504,X
BRA .noframeshit
.frm2
LDA #$02
STA $1504,X
.noframeshit
LDA $1588,x
AND #$04
BEQ .ret
JSR SubSmoke
LDA #$03
STA $1504,X	; flat frame
LDA #$09
STA $1DFC
LDA #$80
STA $163E,x
LDA #$20
STA $1887
LDA #$08
STA $1540,x
INC $C2,x
.ret
RTS

.st3
JSL $01A7DC
BCC .dootherstuff
LDA $140D
BEQ .killmar
LDA $0E
CMP #$E6
BMI .killwhimp
.killmar
LDA $1540,x
BEQ .dootherstuff
JSL $00F5B7
.dootherstuff
LDA $163E,x
BNE .ret22
LDA #$0A
STA $163E,x
LDA #$C0
STA $AA,x
INC $C2,x
.ret22
RTS

.killwhimp
JSL $01AA33
JSL $01AB99
JSL $07FC3B
JSL Shatter
LDA #$02
STA $1DF9
LDA #$07
STA $1DFC
STZ $14C8,x
RTS

.st4
LDA $163E,x
BEQ .frm22
LDA #$02
STA $1504,X
BRA .noframeshit2
.frm22
LDA #$01
STA $1504,X
.noframeshit2
LDA $1588,x
AND #$04
BEQ .ret3
STZ $C2,x
.ret3
RTS

Shatter:
LDA $E4,x             
STA $9A                 
LDA $14E0,x             
STA $9B                 
LDA $D8,x               
STA $98                 
LDA $14D4,x             
STA $99  
PHB
LDA #$02
PHA
PLB
LDA #$00
JSL $028663
PLB
STZ $14C8,x
RTL

SubSmoke:
	LDA #$01	; \ load times to run code
	STA $00		; /
--	LDY #$07	; load times to loop
-	LDA $170B,y	; \ branch if not free slot
	BNE +		; /
	JSR .spawnsmoke	; spawn smoke
	BRA ++		; done searching
+	DEY		; \ loop if not a free slot
	BPL -		; /
++	DEC $00		; \
	LDA $00		;  | loop once more
	BPL --		; /
	RTS		; 
.spawnsmoke
	LDA #$0F	; \ extended sprite number
	STA $170B,y	; /

	LDA $14D4,x	; \
	XBA		;  | 
	LDA $D8,x	;  | 
	REP #$20	;  | 
	CLC		;  | y position from sprite
	ADC #$0008	;  | 
	SEP #$20	;  | 
	STA $1715,y	;  | 
	XBA		;  | 
	STA $1729,y	; /


	LDA $E4,x	; \
	STA $171F,y	;  | x position from sprite
	LDA $14E0,x	;  | 
	STA $1733,y	; /

	PHX		; \
	LDX $00		;  | 
	LDA .xspd,x	;  | set x speed
	PLX		;  | 
	STA $1747,y	; /
	LDA #$10	; \ set timer to live
	STA $176F,y	; /
	RTS		; 
.xspd	db $18,$E8

 ;=========================================;
;Proximity (horizontal)		      
;A will have 1 if the sprite is in range
;Otherwise it's 0			     
;=========================================;

;Store the range to check from in 00, then jump to this routine.
;E.g.
;LDA #$12
;STA $00
;JSR Proximity

DirFix: db $FF,$00

prox:
	LDY #$00
	LDA $E4,x		        ;\
	SEC				            ; |
	SBC $94			         ; |
	PHA				            ; |
	JSR SUB_HORZ_POS	  ; | Check sprite range ..
	PLA				            ; |
	EOR DirFix,y		     ; |
	CMP $00			         ; | If Range > !Temp return.
	BCC +			           ; | If in RANGE.. branch.
 	LDA #$01           ; |
	RTS				            ;/
+	
 	LDA #$00
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP: 
    db $00,$02
    db $20,$22
    db $04,$06
    db $24,$26
    db $44,$46
    db $64,$66
    db $08,$08
    db $60,$62

XDISP:
    db $F8,$08,$F8,$08
YDISP:
    db $F0,$F0,$00,$00
PROP:
    db $0D,$0D,$0D,$0D


Graphics:
	JSR GET_DRAW_INFO 
 LDA $1504,X
 ASL #2
 STA $02
 LDA $1540,X
 STA $03
	PHX
	LDX #$03
Loop:
 LDA $00
 CLC
 ADC XDISP,x
 STA $0300,y
 LDA $01
 CLC
 ADC YDISP,x
 STA $0301,y
 PHX
 TXA
 CLC
 ADC $02
 TAX
 LDA TILEMAP,x
 STA $0302,y
 PLX
 LDA PROP,x
 ORA $64
 STA $0303,y
 INY
 INY
 INY
 INY
 DEX
 BPL Loop
 PLX
 LDY #$02
 LDA #$03
 JSL $01B7B3
	RTS


;region Sprite Routines

;=================;
;SUB_HORZ_POS
;=================;

SUB_HORZ_POS:
	LDY #$00
	LDA $D1
	SEC
	SBC $E4,x
	STA $0F
	LDA $D2
	SBC $14E0,x
	BPL SPR_L16
	INY
SPR_L16:
	RTS

;=================;
;SUB_VERT_POS
;=================;

SUB_VERT_POS:
	LDY #$00
	LDA $D3
	SEC
	SBC $D8,x
	STA $0F
	LDA $D4
	SBC $14D4,x
	BPL SPR_L11
	INY
SPR_L11:
	RTS

;=================;
;SUB_OFF_SCREEN
;=================;

SPR_T12:
	db $40,$B0
SPR_T13:
	db $01,$FF
SPR_T14:
	db $30,$C0,$A0,$C0,$A0,$F0,$60,$90
	db $30,$C0,$A0,$80,$A0,$40,$60,$B0
SPR_T15:
	db $01,$FF,$01,$FF,$01,$FF,$01,$FF
	db $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X1:
	LDA #$02
	BRA STORE_03
SUB_OFF_SCREEN_X2:
	LDA #$04
	BRA STORE_03
SUB_OFF_SCREEN_X3:
	LDA #$06
	BRA STORE_03
SUB_OFF_SCREEN_X4:
	LDA #$08
	BRA STORE_03
SUB_OFF_SCREEN_X5:
	LDA #$0A
	BRA STORE_03
SUB_OFF_SCREEN_X6:
	LDA #$0C
	BRA STORE_03
SUB_OFF_SCREEN_X7:
	LDA #$0E
STORE_03:
	STA $03
	BRA START_SUB
SUB_OFF_SCREEN_X0:
	STZ $03

START_SUB:
	JSR SUB_IS_OFF_SCREEN
	BEQ RETURN_35
	LDA $5B
	AND #$01
	BNE VERTICAL_LEVEL
	LDA $D8,x
	CLC
	ADC #$50
	LDA $14D4,x
	ADC #$00
	CMP #$02
	BPL ERASE_SPRITE
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	AND #$01
	ORA $03
	STA $01
	TAY
	LDA $1A
	CLC
	ADC SPR_T14,y
	ROL $00
	CMP $E4,x
	PHP
	LDA $1B
	LSR $00
	ADC SPR_T15,y
	PLP
	SBC $14E0,x
	STA $00
	LSR $01
	BCC SPR_L31
	EOR #$80
	STA $00
SPR_L31:
	LDA $00
	BPL RETURN_35
	ERASE_SPRITE:
	LDA $14C8,x
	CMP #$08
	BCC KILL_SPRITE
	LDY $161A,x
	CPY #$FF
	BEQ KILL_SPRITE
	LDA #$00
	STA $1938,y
KILL_SPRITE:
	STZ $14C8,x
RETURN_35:
	RTS

VERTICAL_LEVEL:
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	LSR A
	BCS RETURN_35
	LDA $E4,x
	CMP #$00
	LDA $14E0,x
	SBC #$00
	CMP #$02
	BCS ERASE_SPRITE
	LDA $13
	LSR A
	AND #$01
	STA $01
	TAY
	LDA $1C
	CLC
	ADC SPR_T12,y
	ROL $00
	CMP $D8,x
	PHP
	LDA $001D
	LSR $00
	ADC SPR_T13,y
	PLP
	SBC $14D4,x
	STA $00
	LDY $01
	BEQ SPR_L38
	EOR #$80
	STA $00
SPR_L38:
	LDA $00
	BPL RETURN_35
	BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN:
	LDA $15A0,x
	ORA $186C,x
	RTS

;================;
;GET_DRAW_INFO
;================;

SPR_T1:
	db $0C,$1C
SPR_T2:
	db $01,$02

GET_DRAW_INFO:
	STZ $186C,x
	STZ $15A0,x
	LDA $E4,x
	CMP $1A
	LDA $14E0,x
	SBC $1B
	BEQ ON_SCREEN_X
	INC $15A0,x

ON_SCREEN_X:
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC
	SBC $1A
	CLC
	ADC.w #$0040
	CMP.w #$0180
	SEP #$20
	ROL A
	AND #$01
	STA $15C4,x
	BNE INVALID

	LDY #$00
	LDA $1662,x
	AND #$20
	BEQ ON_SCREEN_LOOP
	INY
ON_SCREEN_LOOP:
	LDA $D8,x
	CLC
	ADC SPR_T1,y
	PHP
	CMP $1C
	ROL $00
	PLP
	LDA $14D4,x
	ADC #$00
	LSR $00
	SBC $1D
	BEQ ON_SCREEN_Y
	LDA $186C,x
	ORA SPR_T2,y
	STA $186C,x
ON_SCREEN_Y:
	DEY
	BPL ON_SCREEN_LOOP
	LDY $15EA,x
	LDA $E4,x
	SEC
	SBC $1A
	STA $00
	LDA $D8,x
	SEC
	SBC $1C
	STA $01
	RTS

INVALID:
	PLA
	PLA
	RTS
;endregion